

/*************************************************************************
 * Function     : error()                                                *
 * Description  : It is a standard error function which displays a error *
 *					   supplied by the user at the bottom of the screen       *
 *													                                  *
 *                                                                       *
 * Input Parameters : error as a character string                        *
 *                                                                       *
 *                                                                       *
 * Returns      : None                                                   *
 *                                                                       *
 *************************************************************************/
void error(char str[]) {
	int iCnt;
	char str2[80];
	int iX;
	int iY;

	iX = wherex();
	iY = wherey();
	strncpy(str2,str,70);
	gotoxy(8,25);
	for(iCnt = 0 ; iCnt< 70 ;iCnt++ )
		putchar(' ');
	gotoxy(8,25);
	printf("Error :%s",str);
	getch();
	gotoxy(8,25);
	for(iCnt = 0 ; iCnt< 70 ;iCnt++ )
		putchar(' ');
	gotoxy(iX,iY);
}
/*************************************************************************
 * Function     : message()                                              *
 * Description  : It is a standard message function which displays a mes.*
 *					   supplied by the user at the bottom of the screen       *
 *													                                  *
 *                                                                       *
 * Input Parameters : message as a character string                      *
 *                                                                       *
 *                                                                       *
 * Returns      : None                                                   *
 *                                                                       *
 *************************************************************************/
void message(char str[]) {
	int iCnt;
	int iX;
	int iY;

	iX = wherex();
	iY = wherey();
	gotoxy(8,25);
	for(iCnt = 0 ; iCnt< 70 ;iCnt++ )
	putchar(' ');
	gotoxy(8,25);
	if( str != NULL )
		printf("%-70.70s",str);
	gotoxy(iX,iY);
}

/*************************************************************************
 * Function     : isInt()          						               		 *
 * Description  : Checks if the string supplied is a integer             *
 *													                                  *
 *                                                                       *
 * Input Parameters : char string to be checked                          *
 *                                                                       *
 *                                                                       *
 * Returns      : 0 if string is not a valid integer else                *
 *                returns 1 if it is valid                               *
 *                                                                       *
 *************************************************************************/

int isInt(char * acBuf) { /* Is the string integer */
	int iFlag;
	int iCnt;
	iFlag = 1;
	for( iCnt = 0 ; iCnt < strlen(acBuf) && iFlag ; iCnt++ ) {
		if( !isdigit( acBuf[iCnt] ) )
			iFlag = 0;
	}
	return iFlag;
}

/*************************************************************************
 * Function     : isFloat()        						               		 *
 * Description  : Checks if the string supplied is a float               *
 *													                                  *
 *                                                                       *
 * Input Parameters : char string to be checked                          *
 *                                                                       *
 *                                                                       *
 * Returns      : 0 if string is not a valid float else                  *
 *                returns 1 if it is valid                               *
 *                                                                       *
 *************************************************************************/
int isFloat( char * acBuf) { /* Is the string float */
	int iCnt;
	int iFlag;
	int iCnt2;
	int iStrLen;

	iCnt2=0;
	iFlag=1;
	iStrLen = strlen(acBuf);

	for( iCnt = 0 ; iCnt < iStrLen && iFlag ; iCnt++ ) {
		if( !isdigit( acBuf[iCnt] ) ){
			if( acBuf[iCnt] != '.' )
				iFlag = 0;
			else iCnt2++;
		}
	}
	if( iCnt2 > 1 )
		iFlag=0;
	return iFlag;
}

/*************************************************************************
 * Function     : isAlphaStr()     						               		 *
 * Description  : Checks if the string supplied is a alphabetic string   *
 *													                                  *
 *                                                                       *
 * Input Parameters : char string to be checked                          *
 *                                                                       *
 *                                                                       *
 * Returns      : 0 if string is not a valid alphabetic string else      *
 *                returns 1 if it is valid                               *
 *                                                                       *
 *************************************************************************/
int isAlphaStr( char * acBuf) { /* Is the string only of alphabets and space */
	int iCnt;
	int iFlag = 1;
	for( iCnt = 0 ; iCnt < strlen(acBuf) && iFlag ; iCnt++ ) {
		if( !isalpha(acBuf[iCnt]) ){
			if( acBuf[iCnt] != ' ' )
				iFlag = 0;
		}
	}
	return iFlag;
}
/*************************************************************************
 * Function     : isTitle()     						               		    *
 * Description  : Checks if the string supplied can be a title string    *
 *													                                  *
 *                                                                       *
 * Input Parameters : char string to be checked                          *
 *                                                                       *
 *                                                                       *
 * Returns      : 0 if string is not a valid title string else           *
 *                returns 1 if it is valid                               *
 *                                                                       *
 *************************************************************************/
int isTitle( char * acBuf) { /* Is the string only of alphabets and space */
	int iCnt;
	int iSize;
	int iFlag = 0;

	iSize = strlen(acBuf);
	for( iCnt = 0 ; iCnt < iSize && !iFlag ; iCnt++ ) {
		if( isalpha(acBuf[iCnt]) ){
			iFlag = 1;
		}
	}
	return iFlag;
}

/*************************************************************************
 * Function     : isEmail()      						               		 *
 * Description  : Checks if the string supplied is a alphabetic string   *
 *													                                  *
 *                                                                       *
 * Input Parameters : char string to be checked                          *
 *                                                                       *
 *                                                                       *
 * Returns      : 0 if string is not a valid alphabetic string else      *
 *                returns 1 if it is valid                               *
 *                                                                       *
 *************************************************************************/
int isEmail( char * acBuf) { /* Is the string only of alphabets and space */

	char * pcLocation;

	if( *(acBuf) == 0 )
		return 0;
	if( (pcLocation=strchr(acBuf,'@')) == NULL)
		return 0;
	if( (pcLocation-strrchr(acBuf,'.') )>=0 )
		return 0;
	if( pcLocation!=strrchr(acBuf,'@') )
		return 0;
	if( strstr( acBuf,"..") || strstr( acBuf," ") || strstr( acBuf,".@"))
		return 0;
	if( *acBuf == '.' || acBuf[strlen(acBuf)-1] == '.' )
		return 0;

	return 1;
}

/*************************************************************************
 * Function     : trim()                                                 *
 * Description  : Removes the extra spaces in a string                   *
 *													                                  *
 *                                                                       *
 * Input Parameters :  String name                                       *
 *                                                                       *
 *                                                                       *
 * Returns      : None                                                   *
 *                                                                       *
 *************************************************************************/
void trim(char a[]) {

	int i=0;
	while( a[i] != 0 ) i++;
	if( i>0 ) {
		i--;
		while( a[i] == ' ' )
			i--;
		a[i+1] = 0;
	}

	while( a[0] == ' ' )
	strcpy(&a[0],&a[1]);
	for( i=0 ; a[i]!=0 ; i++ ) {
		if( a[i]==' ' && a[i+1] == ' '){
				strcpy(&a[i],&a[i+1]);
				if( i>0 ) i--;
		}
	}

}



/*************************************************************************
 * Function     :  getstr()                                              *
 * Description  : gets a string from the user that can be upto 30        *
 *					   characters and trims the spaces before returning       *
 *													                                  *
 *                                                                       *
 * Input Parameters :  string name                                       *
 *                                                                       *
 *                                                                       *
 * Returns      : None                                                   *
 *                                                                       *
 *************************************************************************/
char getstr( char str[] ) {
	int iCnt = 0;
	char ch;

	str[0] = 0;
	fflush(stdin);
	do{
		ch = getch();
		if( ch== 8 ) {
			if( iCnt > 0 ) {
				iCnt--;
				putch(8);
			}
		}else{
			if( isprint(ch) && iCnt<(29)) {
				str[iCnt++] = ch;
				putch(ch);
			}
		}
 }while(ch!='\r' && ch!=ESC);
 str[iCnt] = 0;
 trim(str);
 return(ch);
}


/*************************************************************************
 * Function     :  getChoice()                                           *
 * Description  : gets a choice from the user in the range iLow and      *
 *					   iHigh                                                  *
 *													                                  *
 *                                                                       *
 * Input Parameters :  iLow and iHigh chars                              *
 *                                                                       *
 *                                                                       *
 * Returns      : None                                                   *
 *                                                                       *
 *************************************************************************/
char getChoice(char iLow,char iHigh) {
		char choice;
		char cCh=iLow-1;
		choice = iLow-1;
		if( iLow > iHigh )
			return iLow;
		do{
			if( (cCh >=(iLow) && cCh<=(iHigh))&&(choice==iLow-1) ) {
				choice = cCh;
				putchar(cCh);
			}else if( choice >=iLow && choice<=iHigh && cCh == 8){
				choice = iLow-1;
				putchar(8);
			}
			cCh = getch();
		}while( cCh !='\r' || choice < iLow || choice > iHigh );

	return(choice);
}


/*************************************************************************
 * Function     : drawBox()        						               		 *
 * Description  : Displays a standard frame for the application          *
 *													                                  *
 *                                                                       *
 * Input Parameters : None                                               *
 *                                                                       *
 *                                                                       *
 * Returns      : None                                                   *
 *                                                                       *
 *                                                                       *
 *************************************************************************/

 void drawBox(void) {

	char acStr[] = "Library Information System.";
	int iStrLen = strlen(acStr);
	int iCnt;
	int iLength;
	int iWidth;
	int iX;
	int iY;

	iLength = 23;
	iWidth = 76;
	iX =2;
	iY =1;
	if( (iLength+iY)  > 24 )
		iLength = 24 - iY;
	if( (iWidth+iX) > 80 )
		iWidth = 80 - iX;

	for( iCnt = 0 ; iCnt <= iWidth ; iCnt++ ){
		gotoxy(iX+iCnt,iY);
		putch('*');
		gotoxy(iX+iCnt,iY+iLength);
		putch('*');
	}
	gotoxy(iX + (iWidth-iStrLen)/2,iY+2);
	printf(acStr);
	for( iCnt = 1 ; iCnt < (iLength) ; iCnt++ ){
		gotoxy(iX,iY+iCnt);
		putch('*');
		gotoxy(iX+iWidth,iY+iCnt);
		putch('*');
	}

}



/*************************************************************************
 * Function     : login()        						               		 *
 * Description  : Displays the login screen                              *
 *													                                  *
 *                                                                       *
 * Input Parameters : None                                               *
 *                                                                       *
 *                                                                       *
 * Returns      : 1 if password was correctly entered else 0             *
 *                                                                       *
 *                                                                       *
 *************************************************************************/

int login() {
	int iCnt;
	int iCnt2;
	char acPassword[10];
	char cCh;

	iCnt2=0;

	do {

		/* Display the login screen */

		clrscr();
		drawBox();
		gotoxy(34,5);
		printf("Login Module");
		gotoxy(25,13);
		printf("Enter login password :");
		iCnt=0;

		do{

		/* Accept the keys pressed */

		  cCh = getch();
		  if( cCh== 8 ){
			if( iCnt>0 ){

			/* If key was back space and there are '*' characters on the screen reduce one '*' */

				putch(8);
				iCnt--;
			}
		  }else if( cCh!='\r' && iCnt<9 ){

		  /* if the char was not enter or back space put it in
		  password buffer and display '*' on the screen*/

				acPassword[iCnt++] = cCh;
				putch('*');
		  }

		}while( cCh!='\r' );
		acPassword[iCnt] = 0;
		if( strcmp( "lis" , acPassword )!=0 ) {

		/* If password is incorrect show error message
		and increment invalid password count*/

			iCnt2++;
			if( iCnt2 != 3 )
				error("Invalid Login Password Try Again");
			else{

			/* if invalid password is entered more than three times exit
			after giving proper messages*/
				error("Invalid Password. Your three chances are over");
				clrscr();
				drawBox();
				gotoxy(35,12);
				printf("Good Bye");
				return 0;
			}
			iCnt = 0;
		}


	}while( strcmp( "lis" , acPassword ) && iCnt2<3 ) ;

	return 1;


}
