#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include <ctype.h>

#define ESC 27
#define MAXCLIENTS 65535
#define MAXBOOKS 65535
#define MAXRES 65535

#include "strucdef.h" /* Header contains all the structure definitions */
#include "genfun.h" /* Header contains all the general functions for all modules */
#include "exit.h"   /* Header to display the exit screen */
#include "client.h" /* Header contains all the functions related to client maintainence */
#include "book.h"   /* Header contains all the functions related to book maintainence */
#include "res.h"    /* Header contains all the functions related to reservation maintainence */




void main(void)
/* Main begins here */
{

	client * startClient;
	book * startBook;
	res * startRes;
	char cChoice;
	char cResponse;


	if( !login() )
		exit(1);

	/* initialize the start pointers for the linked lists */
	startClient = NULL;
	startBook = NULL;
	startRes = NULL;

	/* Load the data from files into respective lists */
	ini_clients(&startClient);
	ini_books(&startBook);
	ini_res(&startRes);

	do {

		/* Display the form for main menu */

		clrscr();
		drawBox();

		gotoxy(15,8);
		printf("1.Client Maintainence");

		gotoxy(15,10);
		printf("2.Book Maintainence");

		gotoxy(15,12);
		printf("3.Reservation Maintainence");

		gotoxy(15,14);
		printf("0.Exit");

		gotoxy(15,16);
		printf("Enter choice : ");

		message("Enter choice in range 0 to 3");
		cChoice = getChoice('0','3');
		message(NULL);

		switch( cChoice ) {

			case '1' :

				/* If choice is 1 call the clients module to handle client maintainence */

				clients(&startClient,&startRes);
				break;

			case '2' :

				/* If choice is 2 call the books module to handle book maintainence */

				books(&startBook,&startRes,&startClient);
				break;

			case '3' :

				/* If choice is 3 call the reservation module to handle reservation maintainence */

				reservation(&startRes,&startClient,&startBook);
				break;

			case '0' :

				/* If choice is 0 call the exitMenu module to display exit screen */

				cResponse = exitMenu();
				break;
		}
	/* If choice is 0 and user confirms exit then step out of the loop */
	}while( !(cChoice == '0' && cResponse =='Y') );


	/* save the details into respective files and free the lists */
	save_clients(&startClient);
	free_client_list(&startClient);
	save_books(&startBook);
	free_book_list(&startBook);
	save_res(&startRes);
	free_res_list(&startRes);
} /* Main ends here */
